package helloworld

import (
	"appengine"
	"appengine/datastore"
	"template"
    "fmt"
    "http"
)

type Message struct {
	Name	string
	Content	string
	Email	string
	Date	datastore.Time
}

func init(){
    http.HandleFunc("/", view)
	http.HandleFunc("/post", post)
}

func view(w http.ResponseWriter, r *http.Request) {
	c := appengine.NewContext(r)

	//f[^ǂݍ
	q := datastore.NewQuery("Message").Order("-Date").Limit(10)
	messages := make([]Message, 0)
	_, err := q.GetAll(c, &messages)
	if err != nil {
		fmt.Fprintf(w, "error")
		return
	}

	tmpl := template.Must(template.New("view").Parse(inputTmpl))
	tmpl.Execute(w, messages)
}

const inputTmpl = `
<html>
	<head>
		<title>the bbs</title>
		<link rel="stylesheet" type="text/css" href="css/style.css" />
	</head>
	<body>
		{{range .}}
			<div class="message">
				<p class="author">author : {{html .Name}} email : {{html .Email}}</p>
				<p class="content"> {{html.Content}}</p>
			</div>
		{{end}}
		<div class="post">
		<form action="/post" method="post">
			<div>
			<input type="submit" value="post"></input>
			name : <input name="uname" type="text"></input>
			email : <input name="mail" type="text"></input></div>
			<div><textarea rows="5" cols="60" name="content"></textarea></div>
		</form>
		<div>
	</body>
</html>
`

func post(w http.ResponseWriter, r *http.Request){
	c := appengine.NewContext(r)

	//f[^
	var data Message
	data.Name = r.FormValue("uname")
	data.Content = r.FormValue("content")
	data.Email = r.FormValue("mail")
	_,err := datastore.Put(c, datastore.NewIncompleteKey(c, "Message", nil), &data)
	if err != nil {
		fmt.Fprintf(w,"error")
		return
	}
	http.Redirect(w, r, "/", http.StatusFound)
	return
}
