package memcachetest

import (
	"fmt"
	"http"
	"appengine"
	"appengine/memcache"	//pbP[WC|[g
)

func init(){
	http.HandleFunc("/set",set)
	http.HandleFunc("/get",get)
	http.HandleFunc("/del",del)
}

func set(w http.ResponseWriter, r *http.Request){
	c := appengine.NewContext(r)

	//ACe
	item := &memcache.Item{
		Key			:	"message",
		Value		:	[]byte("hello memcache!"),
		Expiration	:	60,
	}
	//ACei[ɂSet()g
	err := memcache.Set(c, item)
	if err == memcache.ErrNotStored {
		fmt.Fprintf(w, "Item is already exist for its key.")
	}else if err != nil {
		c.Infof("error with memcache.Set() -> %s", err.String())
		fmt.Fprintf(w, "error with memcache.")
	}

	fmt.Fprintf(w, "Item was set to memcache.")
}

func get(w http.ResponseWriter, r *http.Request){
	c := appengine.NewContext(r)

	//ACe擾ɂGet()g
	item, err := memcache.Get(c, "message");
	if err != nil {
		c.Infof("error with memcache.Get() -> %s", err.String())
		fmt.Fprintf(w, "memcache item is not found.")
		return
	}
	fmt.Fprintf(w, "%s", item.Value)
}

func del(w http.ResponseWriter, r* http.Request) {
	c := appengine.NewContext(r)

	//ACe폜ɂDelete()g
	err := memcache.Delete(c, "message")
	if err != nil {
		c.Infof("error with memcache.Delete() -> %s", err.String())
		fmt.Fprintf(w, "item could not be deleted.")
		return
	}
	fmt.Fprintf(w, "item was deleted.",)
}