package usertest

import (
	"fmt"
	"http"
	"template"
	"appengine"
	"appengine/user"
)

type TEMPSUB struct {
	User	string
	Url		string
}

func init(){
	http.HandleFunc("/", root)
	http.HandleFunc("/login", login)
	http.HandleFunc("/logined", logined)
}

func root(w http.ResponseWriter, r *http.Request){
	fmt.Fprintf(w, root_html)
}

//rooty[WHTML
var root_html = `
<html>
	<body>
		<form action="/login" method="post">
			<input type="text" name="identity" value="input identity" />
			<input type="submit" value="post" />
		</form>
	</body>
</html>
`

func login(w http.ResponseWriter, r *http.Request) {
    c := appengine.NewContext(r)

    //postf[^identity擾
    identity := r.FormValue("identity")

    //OCpURL擾
    login_url, err := user.LoginURLFederated(c, "/logined", identity)

    if err != nil {
        fmt.Fprintf(w, "error.")
        return
    }
	http.Redirect(w, r, login_url, http.StatusFound)
}

func logined(w http.ResponseWriter, r *http.Request) {
	c := appengine.NewContext(r)

	u := user.Current(c)
	if u == nil {
		//OCĂȂ
		http.Redirect(w, r, "/", http.StatusFound)
	}

	//logoutpurl擾
	logout_url, err := user.LogoutURL(c, "/")
	if err != nil {
		fmt.Fprintf(w, "error.")
		return
	}

	tmpl_data := &TEMPSUB {
		User : u.FederatedIdentity,
		Url  : logout_url,
	}
	tmpl := template.Must(template.New("Logined").Parse(logined_template))
	tmpl.Execute(w, tmpl_data)
}

//loginedy[W̃ev[g
var logined_template = `
<html>
	<body>
		<p> your identity : {{.User}}</p>
		<a href="{{.Url}}">logout</a>
	</body>
</html>
`